package br.com.previna.controllers;

import static javax.ws.rs.core.Response.Status.UNAUTHORIZED;

import java.io.IOException;
import java.util.UUID;

import javax.persistence.NoResultException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;

import br.com.previna.util.SendMail;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.log4j.Logger;

import br.com.previna.bo.UserBO;
import br.com.previna.dto.AuthDTO;
import br.com.previna.model.Token;
import br.com.previna.model.User;
import br.com.previna.util.TokenGenerator;


@Path("auth")
public class AuthController {
	Logger logger = Logger.getLogger("controller.AuthController");
	private UserBO userBO = new UserBO();

	@Context
	private HttpServletResponse response;
	@Context
	private HttpServletRequest request;

	@POST
	@Path("/login")
	@Consumes("application/json; charset=UTF-8")
	@Produces("application/json; charset=UTF-8")
	public Response login(User userLogin) throws IOException {
		User user;
		Token token=new Token();
		try {
			ObjectMapper mapper = new ObjectMapper();
			user = userBO.userExists(userLogin);
			token.setToken(TokenGenerator.issueToken(mapper.writeValueAsString(user)));
		} catch (Exception e) {
			e.printStackTrace();
			return Response.status(UNAUTHORIZED).build();
		}
		return Response.ok().entity(new AuthDTO(user, token)).build();
	}


	@POST
	@Path("/recoverPasswordRequest")
	@Consumes("application/json; charset=UTF-8")
	@Produces("application/json; charset=UTF-8")
	public Response recoverPasswordRequest(User userLogin) throws IOException {
		return Response.ok().entity("da").build();
	}

	@POST
	@Path("/enviarEmail")
	@Consumes("application/json; charset=UTF-8")
	@Produces("application/json; charset=UTF-8")
	public Response enviaEmailRecuperaSenha(User userEmail){
		try {
			User recuperando= userBO.getUserByEmail(userEmail.getEmail());
			recuperando.setUuid(UUID.randomUUID().toString());
			SendMail.sendMailPasswordRecovery(recuperando);
			userBO.updateUser(recuperando);

		} catch (NoResultException e) {
			return Response.ok().entity("Usuário não encontrado").status(Response.Status.BAD_REQUEST).build();
		} catch (Exception e) {
			return Response.ok().entity(e.getMessage()).status(Response.Status.BAD_REQUEST).build();
		}
		return Response.ok().status(Response.Status.OK).build();
	}

	@POST
	@Path("/recuperarSenha")
	@Consumes("application/json; charset=UTF-8")
	@Produces("application/json; charset=UTF-8")
	public Response trocaSenhaUsuario(@HeaderParam("uuid") String uuid, User user){
		try {
			User recuperando= userBO.getUserByEmail(user.getEmail());
			if(recuperando.getUuid().equals(uuid)) {
				recuperando.setUuid("");
				userBO.recuperaSenha(recuperando, user.getPassword());
			}
		} catch (Exception e) {
			e.printStackTrace();
			return Response.ok().status(Response.Status.BAD_REQUEST).build();
		}
		return Response.ok().status(Response.Status.OK).build();
	}

}
